#ifndef MRK_LEXER_INTERNAL
#define MRK_LEXER_INTERNAL

#include "mrk/lexer.h"

struct mrk_lexer {
  struct {
    const char *s;
    size_t len;
  } buf;
  struct {
    size_t line;
    size_t line_index;
    size_t buf_index;
  } pos;
  struct {
    size_t start;
    size_t end;
  } token;
};

/**
 * Return the next character that would be consumed by a call to advance. At the
 * end of the buffer, this value is nul.
 */
char mrk_lexer_peek(mrk_lexer *lexer);

/**
 * Advance the current position by one character, adding the new character to
 * the curent token's context and returning it.
 */
char mrk_lexer_advance(mrk_lexer *lexer);

/**
 * Output the currently matched token to the token struct with the given type,
 * and reset the lexer's tracked token.
 */
void mrk_lexer_emit(mrk_token *out, mrk_lexer *lexer, mrk_token_type type);

#endif
